//	ATmega88
//	LM317gp ϓdiȈՓdvEȈՓdvtj

/*
|[gΉ	[ATmega88]	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	-	-	-	-	-	-	-	CKO		PB0:VXeNbNo
portC	x	x	-	-	-	-	VM	AM		ADC(PC1:dv, PC0:dv)
portD	-	E	RS	-	DB7	DB6	DB5	DB4		LCDڑ

yq[Yrbgz(avrsp.exe -rf)	VXeNbNo͂ȊO͍Hoאݒ
Low: 00100010
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PB0ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11111
     |||||+++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----001
          ||+-- BOOTRST f[^V[gQ
          ++-- BOOTSZ[1:0] f[^V[gQ

rh
WinAVR-20080610		œKIvV:-Os	wCuǉ:libm.a
ATmega88	1MHzi8MHz8j


2011/04/17	v1.00	Program:    2498 bytes (30.5% Full)
					Data:         37 bytes (3.6% Full)
				E
*/


#include	<avr/io.h>
#include	<avr/sleep.h>
#include	<avr/interrupt.h>
#include	"lcdlib.h"		//F_CPU`<util/delay.h>܂

//Vref(V)
#define	F_VREF	2.495	//VgM[^

//dp̃VgR()
#define	F_SHUNT_R	0.47

//dp̕R(k)
#define	F_VMETER_RA	10.0	//ADC͓_GND
#define	F_VMETER_RB	30.0	//ADC͓_H

//obt@TCY
//total()̌ʂI[o[t[Ȃ悤60ȉł邱Ɓi10ŏ\j
#define	BUFSIZE	10

//\ʒu
#define	VOLTAGE_X	0
#define	VOLTAGE_Y	0
#define	CURRENT_X	0
#define	CURRENT_Y	1


//bPʂ̎ԑ҂
void	delay_sec(uint8_t sec)
{
	uint8_t	i, m;
	for (i = 0; i < sec; i++)
		for (m = 0; m < 5; m++)
			_delay_ms(200);
}

//LCD̕\1s
void	lcdLineClear(uint8_t y)
{
	lcdSetPos(0, y);
	lcdPutStr("        ");	//8
}

//d\
//F	mVPʂ̒l
void	lcdPutVoltage(uint16_t mValue)
{
	uint16_t	num, dec;
	
	lcdLineClear(VOLTAGE_Y);
	lcdSetPos(VOLTAGE_X, VOLTAGE_Y);
	
	num = mValue / 1000;	//
	dec = mValue % 1000;	//
	
	//10mV͏2ʂ܂ŕ\i3ʈȉ͐؂̂āj
	//10mVȏ͏1ʂ܂ŕ\i2ʈȉ͐؂̂āj
	//[9.99][10.0]mV
	if (num < 10)
	{
		lcdPutChar(' ');
		lcdPutUInt(num);
		lcdPutChar('.');
		//32\i3ڂ͐؂̂āj
		dec /= 10;
		if (dec < 10) lcdPutChar('0');
		lcdPutUInt(dec);
	}
	else
	{
		lcdPutUInt(num);
		lcdPutChar('.');
		//31\i2ڈȍ~͐؂̂āj
		lcdPutUInt(dec / 1000);
	}
	
	lcdPutStr(" V");
}

//d\
//F	0.1mAPʂ̒l
void	lcdPutCurrent(uint16_t mValue)
{
	uint16_t	num, dec;
	
	lcdLineClear(CURRENT_Y);
	lcdSetPos(CURRENT_X, CURRENT_Y);
	
	num = mValue / 10;	//
	dec = mValue % 10;	//
	
	//100mA͏1ʂ܂ŕ\
	//100mAȏ͐̂ݕ\i_ȉ͐؂̂āj
	//[99.9][100]mA
	if (num < 100)
	{
		if (num < 10) lcdPutChar(' ');
		lcdPutUInt(num);
		lcdPutChar('.');
		lcdPutUInt(dec);
	}
	else
	{
		if (num < 1000) lcdPutChar(' ');
		lcdPutUInt(num);
	}
	
	lcdPutStr(" mA");
}

//obt@̒lv
uint16_t	total(uint16_t values[])
{
	uint8_t	i;
	uint16_t	n = 0UL;
	for (i = 0; i < BUFSIZE; i++) n += values[i];
	return n;
}

//A/DϊX[v̕A
ISR(ADC_vect)
{
	//Ȃ
}

//ADMUXɐݒ肷dƓ̓s̓e
//REFS0 -> 00:AREF, 01:AVCC, 11:1.1V
//MUX0  -> 0111-0000:PC7-PC0, 1110:I1.1Vڑ, 1111:I0Vڑ
#define	ADC_SET_CURRENT	((0b00 << REFS0) | (0b0000 << MUX0))
#define	ADC_SET_VOLTAGE	((0b00 << REFS0) | (0b0001 << MUX0))

int	main(void)
{
	uint16_t	adcVoltages[BUFSIZE] = {0UL};
	uint16_t	adcCurrents[BUFSIZE] = {0UL};
	uint16_t	adcValue;
	uint16_t	mVoltage, mCurrent;
	uint8_t	idx;
	float	fv, fa;
	
	lcdInit();	//LCD
	
	//LCD\
	lcdSetPos(0, VOLTAGE_Y);	lcdPutStr("Voltage");
	lcdSetPos(0, CURRENT_Y);	lcdPutStr("Current");
	delay_sec(3);
	
	//mCYጸ҂ADC̃|[gvAbvĂ
	DDRC	= 0b00000000;	//portCS͕
	PORTC	= ~((1 << PC0) | (1 << PC1));	//gpADC̓sȊOvAbv
	
	//d͍팸̂ADCgpsfW^͋֎~ɂiADĆiAiOjpƂȂj
	DIDR0 |= (1 << ADC0D) | (1 << ADC1D);	//PC0,PC1
	
	//ADCݒ
	ADCSRA = 0b10000100		//bit2-0: 100 = 16	1MHz/16=62.5kHz (50k`200kHzł邱)
		| (1 << ADIE);		//荞݋iX[vΉj
	
	//ADC̊dƓ̓sݒ肷
	ADMUX =	ADC_SET_VOLTAGE;
	
	//A/DϊmCYጸ̃X[v[hݒ肷
	set_sleep_mode(SLEEP_MODE_ADC);
	sei();			//荞݋
	sleep_mode();	//A/DRo[^ƂďϊJncϊcϊ
	adcValue = ADC;	//l̓ǂݎ̂
	
	idx = 0;
	while(1)
	{
		//===== d𑪒肷 =====
		ADMUX =	ADC_SET_VOLTAGE;
		_delay_ms(10);	//҂
		sleep_mode();	//X[v[h˓cϊcϊ
		
		adcVoltages[idx] = ADC;
		adcValue = total(adcVoltages);
		
		//A/Dϊld߂
		fv = ((float)adcValue / BUFSIZE) * (F_VREF * 1000) / 1024;	//mVP
		fv *= (F_VMETER_RA + F_VMETER_RB) / F_VMETER_RA;	//Ăl{̓d߂
															//fv=F_VREFƂl\ȏlł
		//␳
		//eX^[ł̎lƔrāAvZlF_VREF𒆐Sɖ1Ă̂ŕ␳B
		//EvZlF_VREF傫ƂA̒l͎l1傫B
		//EvZlF_VREF菬ƂA̒l͎l1B
		fv -= (fv - F_VREF * 1000) * 0.01;	//fvmVPʂł邱Ƃɒ
		
		//d\
		mVoltage = (uint16_t)fv;
		lcdPutVoltage(mVoltage);
		
		//===== d𑪒肷 =====
		ADMUX =	ADC_SET_CURRENT;
		_delay_ms(10);	//҂
		sleep_mode();	//X[v[h˓cϊcϊ
		
		adcCurrents[idx] = ADC;
		adcValue = total(adcCurrents);
		
		//A/Dϊld߁AdZo
		fv = ((float)adcValue / BUFSIZE) * (F_VREF * 1000) / 1024;	//mVP
		fa = fv / F_SHUNT_R;	//mAP
		
		//d\
		mCurrent = (uint16_t)(fa * 10.0);	//0.1mAP
		lcdPutCurrent(mCurrent);
		
		//̃[v̏
		if (++idx == BUFSIZE) idx = 0;
	}
	
	return 0;
}
